"""
Delta compression method for vector data, by Luis A. Leiva.
Dual licensed under the MIT and GPL licenses.
"""

def deltaCompression(samples):
  """Performs delta compression over samples [ [v11,...,v1N], ... [vn1,...,vnN] ]."""
  output = [ samples[0] ]
  N, dim = len(samples), len(samples[0])
  for i in range(1,N):
    delta = [0.0] * dim
    for d in range(dim):
      delta[d] = samples[i][d] - samples[i-1][d]
    output.append(delta)
  return output  
