class LZW:
  """
  LZW algorithm, shamelessly adapted by Luis A. Leiva from rosettacode.
  See original code at http://rosettacode.org/wiki/LZW_compression#Python
  """
  
  def __init__(self):
    pass
    
  def makeDict(self):
    self.size = 256
    self.dict = dict((chr(i), chr(i)) for i in xrange(self.size))
    # in Python 3: self.dict = {chr(i): chr(i) for i in range(self.size)}
        
  def encode(self, data):
    self.makeDict()
    output = []
    w = ""
    for c in data:
      wc = w + c
      if wc in self.dict:
        w = wc
      else:
        output.append(self.dict[w])
        self.dict[wc] = self.size
        self.size += 1
        w = c
    if w:
      output.append(self.dict[w])
    return output
    
  def decode(self, data):
    self.makeDict()
    w = result = data.pop(0)
    for k in data:
      if k in self.dict:
        entry = self.dict[k]
      elif k == self.size:
        entry = w + w[0]
      else:
        raise ValueError('Bad compressed key: %s' % k)
      result += entry
      self.dict[self.size] = w + entry[0]
      self.size += 1
      w = entry
    return result
